#!/usr/bin/python
#
from django.core import management
import settings as settings
management.setup_environ(settings)

from main.models import Plant, Report
import datetime
from django.template.loader import render_to_string

if __name__ == "__main__":
    now = datetime.datetime.utcnow() - datetime.timedelta(seconds=2)
    
    plant_reports = Report.objects.new_report_data(now)
    
    for plant_report in plant_reports:
        plant = Plant.objects.get(id=plant_report.plant_id)
        plant_report.timezone = plant.timezone
        if plant_report.report_id:
            if plant_report.alarms:
                report_text = render_to_string("report/alarm_report.txt", {"plant":plant, "alarm_report":plant_report})
                report_html = render_to_string("report/alarm_report.html", {"plant":plant, "alarm_report":plant_report})
                report = Report(plant=plant,timestamp=plant_report.timestamp_to,type=1,report_text=report_text,report_html=report_html)
                try:
                    report.save()
                except Warning:
                    pass
        else:
            report = Report(plant=plant,timestamp=now,type=1,timestamp_sent=now)
            try:
                report.save()
            except Warning:
                pass