from django.conf.urls.defaults import *
import os
from django.conf import settings
import deploy

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()


urlpatterns = patterns('',
    # Example:
    # (r'^zgbtours/', include('zgbtours.foo.urls')),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    (r'^admin/', include(admin.site.urls)),


    (r'^$', "project.main.common.frontpage"),
    (r'^p/(.*)/(?P<id>\d+)/$', "project.main.page.show"),

    (r'^page/list/$', "project.main.page.list"),
    (r'^page/edit/(?P<plant_id>\d+)/$', "project.main.page.edit"),
    (r'^page/edit/(?P<plant_id>\d+)/(?P<id>\d+)/$', "project.main.page.edit"),
    (r'^page/delete/(?P<plant_id>\d+)/(?P<id>\d+)/$', "project.main.page.delete"),
    (r'^page/delete/(?P<id>\d+)/$', "project.main.page.delete"),
    (r'^page/edit/get_order_area/(?P<parent_page>\d+)/(?P<current_page>\d+)/$', "project.main.page.get_order_area"),
    (r'^page/toggle_public/(?P<plant_id>\d+)/(?P<id>\d+)/$', "project.main.page.toggle_public"),
    (r'^page/toggle_public/(?P<id>\d+)/$', "project.main.page.toggle_public"),
    (r'^page/toggle_published/(?P<plant_id>\d+)/(?P<id>\d+)/$', "project.main.page.toggle_published"),
    (r'^page/toggle_published/(?P<id>\d+)/$', "project.main.page.toggle_published"),
    (r'^page/site_list/$', "project.main.page.site_list"),
    (r'^plant/list/$', "project.main.plant.list"),
    (r'^plant/edit/$', "project.main.plant.edit"),
    (r'^plant/edit/(?P<id>\d+)/$', "project.main.plant.edit"),
    (r'^plant/change_order/(?P<direction>\w+)/(?P<id>\d+)/$', "project.main.plant.change_order"),
    (r'^plant/delete/(?P<id>\d+)/$', "project.main.plant.delete"),
    (r'^plant/toggle_public/(?P<id>\d+)/$', "project.main.plant.toggle_public"),
    (r'^plant/page_list/(?P<id>\d+)/$', "project.main.page.plant_page_list"),

    (r'^user/list/$', "project.main.user.list"),
    (r'^user/edit/$', "project.main.user.edit"),
    (r'^user/edit/(?P<id>\d+)/$', "project.main.user.edit"),
    (r'^user/delete/(?P<id>\d+)/$', "project.main.user.delete"),
    (r'^user/toggle_active/(?P<id>\d+)/$', "project.main.user.toggle_active"),
    (r'^profile/edit/$', "project.main.user.edit_profile"),

    (r'^template/list/$', "project.main.template.list"),
    (r'^template/edit/$', "project.main.template.edit"),
    (r'^template/edit/(?P<id>\d+)/$', "project.main.template.edit"),
    (r'^template/delete/(?P<id>\d+)/$', "project.main.template.delete"),
    (r'^template/toggle_published/(?P<id>\d+)/$', "project.main.template.toggle_published"),
    (r'^template/change_order/(?P<direction>\w+)/(?P<id>\d+)/$', "project.main.template.change_order"),

    (r'^controller/list/$', "project.main.controller.list"),
    (r'^controller/edit/$', "project.main.controller.edit"),
    (r'^controller/edit/(?P<id>\d+)/$', "project.main.controller.edit"),
    (r'^controller/delete/(?P<id>\d+)/$', "project.main.controller.delete"),
    (r'^controller/toggle_active/(?P<id>\d+)/$', "project.main.controller.toggle_active"),

    (r'^mmanager/list/$', "project.main.mmanager.list"),
    (r'^mmanager/select_image/(?P<plant_id>\d+)/$', "project.main.mmanager.select_image"),

    (r'^server_admin/$', "project.main.server_admin.index"),
    (r'^server_admin/edit_cfg/(?P<cfg_file>\d+)/$', "project.main.server_admin.edit_config"),
    (r'^server_admin/dump_db/(?P<what>\w+)/$', "project.main.server_admin.dump_db"),
    (r'^server_admin/view_log_file/(?P<log_file>.*)/$', "project.main.server_admin.view_log_file"),
    (r'^server_admin/view_db_info/$', "project.main.server_admin.view_db_info"),
    (r'^server_admin/restart_scgi_server/$', "project.main.server_admin.restart_scgi_server"),
    (r'^server_admin/test_timeout/$', "project.main.server_admin.test_timeout"),
    (r'^server_admin/test_timeout/get_data/$', "project.main.server_admin.test_timeout_get_data"),

    (r'^accounts/login/$', "project.main.user.login"),
    (r'^signout/$', "project.main.user.signout"),

    (r'^service/check_username_password/$', "project.main.user.check_username_password"),
    (r'^service/username_exists/(?P<username>.*)/$', "project.main.user.username_exists"),
    (r'^service/valid_email/(?P<email>(.*))/$', "project.main.user.valid_email"),
    (r'^scgi/$', "project.main.common.create_comm_request"),
    (r'^service/get_timeplot_data/(?P<params>.*)/$', "project.main.timeplot.get_timeplot_data"),
    (r'^service/download_timeplot_data/(?P<params>.*)/$', "project.main.timeplot.download_timeplot_data"),
    (r'^service/alarms/get/(?P<plant_id>\d+)/(?P<nad>\w+)/(?P<filter_type>\w+)/(?P<filter_activity>\w+)/(?P<items_per_page>\d+)/(?P<page_index>\d+)/(?P<rw_access>\d+)/(?P<download_btn>\d+)/$', "project.main.alarm.get_alarms"),
    (r'^service/alarms/download/(?P<plant_id>\d+)/(?P<nad>\w+)/(?P<filter_type>\w+)/(?P<filter_activity>\w+)/(?P<items_per_page>\d+)/(?P<page_index>\d+)/$', "project.main.alarm.download_alarms"),
    (r'^service/alarms/ack/(?P<id>\d+)/$', "project.main.alarm.ack_alarm"),
    (r'^service/get_available_user_list/$', "project.main.user.get_available_user_list"),
    (r'^service/get_user_list_row/(?P<id>\d+)/$', "project.main.user.get_user_list_row"),
    (r'^service/get_available_controller_list/$', "project.main.controller.get_available_controller_list"),
    (r'^service/get_controller_list_row/(?P<id>\d+)/$', "project.main.controller.get_controller_list_row"),
    (r'^service/set_relay_data/(?P<id>\d+)/(?P<enabled>\d+)/(?P<session_id>.*)/$', "project.main.user.set_relay_data"),
    (r'^service/get_relay_data/(?P<id>\d+)/$', "project.main.user.get_relay_data"),
    (r'^service/reset_relay_data/(?P<id>\d+)/$', "project.main.user.reset_relay_data"),
    (r'^service/nad_valid/(?P<nad>.*)/$', "project.main.controller.nad_valid"),

    (r'^timeplot/(?P<timeplot_id>.*)/(?P<graphstyle>.*)/(?P<tags>.*)/(?P<min>.*)/(?P<max>.*)/(?P<colors>.*)/(?P<decimals>.*)/(?P<legend_labels>.*)/(?P<legend_unit>.*)/(?P<show_legend>.*)/(?P<page>.*)/$', "project.main.timeplot.show_fullscreen"),
    
    (r'^test_report/$', "project.main.report.test_alarms_report"),
)

if not deploy.WEB_DEPLOY:
    urlpatterns += patterns('',
        (r'^img/(.*)$', 'django.views.static.serve', {'document_root': os.path.join(settings.PROJECT_PATH, '..', 'static/img')}),
        (r'^inc/(.*)$', 'django.views.static.serve', {'document_root': os.path.join(settings.PROJECT_PATH, '..', 'static/inc')}),
        (r'^data/(.*)$', 'django.views.static.serve', {'document_root': os.path.join(settings.PROJECT_PATH, '..', 'data/')}),
        (r'^static/(.*)$', 'django.views.static.serve', {'document_root': os.path.join(settings.PROJECT_PATH, '..', 'static')}),
    )
